// Gerard Paresys
// 11 06 2012
// Le dossier data doit comporter:
//   lesmaries_mme.wav
//   lesmaries_mme_Pitch_listing.txt
//   lesmaries_mme_Intensity_listing.txt
//   Helvetica-50.vlw
// Touche S Sauve l'ecran (format png)
// Annuler Commentaire sur les 3 lignes qui commencent par: // NomFichier
// pour ouvrir n'importe quel fichier

/**
 * Touche Espace    Pause <br>
 * Touche Fleche <- Zoom Out <br>
 * Touche Fleche -> Zoom In <br>
 * Clic souris dans la fenêtre d'abord <br> <br>
 * Ouvre et joue le fichier Audio lesmaries_mme.wav <br>
 * Ouvre le fichier texte lesmaries_mme_Pitch_listing.txt généré par <a href=http://www.fon.hum.uva.nl/praat/> Praat</a> <br>
 * Ouvre le fichier texte lesmaries_mme_Intensity_listing.txt généré par <a href=http://www.fon.hum.uva.nl/praat/> Praat</a> <br>
 * Dessine les courbes Pitch et Intensity synchronisées avec l'Audio <br>
 * La courbe Pitch n'est pas dessinée quand pitch est "undefined" <br>
 * Chronomètre... <br>
 */

import ddf.minim.*;  // pour AudioPlayer

PFont maFonte;
String NomFichierAudio = "lesmaries_mme.mp3";
String NomFichierPitch = "lesmaries_mme_Pitch_listing.txt";
String NomFichierIntensity = "lesmaries_mme_Intensity_listing.txt";
String[] LignesPitch;
String[] LignesIntensity;
int IndexPitch = 0;
int IndexIntensity = 0;
float xAvantPitch, xApresPitch, yAvantPitch, yApresPitch;
float xAvantIntensity, xApresIntensity, yAvantIntensity, yApresIntensity;
int LigneText, x;
AudioPlayer player;
Minim minim;
float temps, DureeFichier;
boolean Probleme = false, Fin = false;
boolean ToucheEspace = false, Pause = false, Trace = false;
float[] LignePitch, LigneIntensity;
float TempsPause, TempsDebutPause = 0, FacteurX = 8;

void setup() {
  size(800, 600);  // "The size() function must be the first line in setup()"
  maFonte = loadFont("Helvetica-50.vlw");
  smooth();
  background(255);
  stroke(160);
  textAlign(LEFT, TOP);

  // NomFichierPitch = selectInput("select a Pitch File");
  if (loadStrings(NomFichierPitch) == null) { 
    println("Le fichier " + NomFichierPitch + " n'existe pas");
    Probleme = true;
  } 
  else {
    LignesPitch = loadStrings(NomFichierPitch);
    println("Ouverture de: " + NomFichierPitch +"  " + LignesPitch.length + " lignes" );
  } 

  // NomFichierIntensity = selectInput("select an Intensity File");
  if (loadStrings(NomFichierIntensity) == null) { 
    println("Le fichier " + NomFichierIntensity + " n'existe pas");
    Probleme = true;
  } 
  else {
    LignesIntensity = loadStrings(NomFichierIntensity);
    println("Ouverture de: " + NomFichierIntensity +"  " + LignesIntensity.length + " lignes" );
  } 

  // NomFichierAudio = selectInput("select an Audio File (wav, aiff, mp3...");
  if (loadStrings(NomFichierAudio) == null) { 
    println("Le fichier " + NomFichierAudio + " n'existe pas");
    Probleme = true;
  } 
  else {
    println("Ouverture de: " + NomFichierAudio);
    minim = new Minim(this);
    player = minim.loadFile(NomFichierAudio, 2048);
  }

  if (! Probleme) { 
    player.play();

    LignePitch = float(split(LignesPitch[LignesPitch.length - 1 ], "   "));
    DureeFichier = LignePitch[0];
    println("Duree " + NomFichierPitch + " = " + DureeFichier + " sec");

    LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1 ], "   "));
    DureeFichier = LigneIntensity[0];
    println("Duree " + NomFichierIntensity + " = " + DureeFichier + " sec");

    EffaceEcran();
    TempsPause = millis();
  }
  else exit();
}

void draw() {
  temps = millis() - TempsPause;

  if ((! Pause) && (! Fin)) AfficheTemps(temps);
  temps = temps / 1000;

  if (IndexPitch < LignesPitch.length) {
    LignePitch = float(split(LignesPitch[IndexPitch], "   "));
    if (Float.isNaN(LignePitch[0])) {
      IndexPitch = IndexPitch + 1;
    }
    if (IndexPitch < 0) {  //Astuce IndexPitch est > 0
      LigneText = (IndexPitch * 14) + 20;
      fill(0, 0, 255);
      text(LignePitch[0], 50, LigneText);
      fill(255, 0, 0);
      text(LignePitch[1], 100, LigneText);
    }
    // println("temps = " + temps + "  LignePitch[0] = " + LignePitch[0]);
    if ((temps > LignePitch[0]) && ! Pause) {
      xApresPitch = FacteurX * (width) * LignePitch[0] / DureeFichier;      
      if (((xAvantPitch % width) > (xApresPitch % width)) && (IndexPitch < LignesPitch.length - 10) ) EffaceEcran();
      if (Float.isNaN(LignePitch[1])) {
        IndexPitch = IndexPitch + 1;
        Trace = false;
        xAvantPitch = xApresPitch; 
        // println("NaN IndexPitch = " + IndexPitch);
      }
      else {
        yApresPitch = YPitch(LignePitch[1]) ;
        if (Trace) {
          stroke(0, 0, 0); // Ligne noire
          line(xAvantPitch % width, yAvantPitch, xApresPitch % width, yApresPitch);
        }
        xAvantPitch = xApresPitch;    
        yAvantPitch = yApresPitch;
        Trace = true;
        IndexPitch = IndexPitch + 1;
      }
    }
  } 
  else Fin = true;

  if (IndexIntensity < LignesIntensity.length) {
    LigneIntensity = float(split(LignesIntensity[IndexIntensity], "   "));
    if (Float.isNaN(LigneIntensity[0])) {
      IndexIntensity = IndexIntensity + 1;
    }
    if (IndexIntensity < 0) {  //Astuce IndexIntensity est > 0
      LigneText = (IndexIntensity * 14) + 20;
      fill(0, 0, 255);
      text(LigneIntensity[0], 50, LigneText);
      fill(255, 0, 0);
      text(LigneIntensity[1], 100, LigneText);
    }
    // println("temps = " + temps + "  LigneIntensity[0] = " + LigneIntensity[0]);
    if ((temps > LigneIntensity[0]) && ! Pause) {
      xApresIntensity = FacteurX * (width) * LigneIntensity[0] / DureeFichier;      
      if (((xAvantIntensity % width) > (xApresIntensity % width)) && (IndexIntensity < LignesIntensity.length - 10)) {
        EffaceEcran();
      }
      if (Float.isNaN(LigneIntensity[1])) {
        IndexIntensity = IndexIntensity + 1;
        // Trace = false;
        xAvantIntensity = xApresIntensity; 
        // println("NaN IndexIntensity = " + IndexIntensity);
      }
      else {
        yApresIntensity = YIntensity(LigneIntensity[1]) ;
        //if (Trace) {
        stroke(255, 0, 0); // Ligne rouge
        line(xAvantIntensity % width, yAvantIntensity, xApresIntensity % width, yApresIntensity);
        //}
        xAvantIntensity = xApresIntensity;    
        yAvantIntensity = yApresIntensity;
        Trace = true;
        //IndexIntensity = IndexIntensity + 1;
        IndexIntensity = IndexIntensity + 5;
      }
    }
  }
  else Fin = true;
}

float YPitch(float w) {
  return ((500 - w) / 2) + 100;
}

float YIntensity(float w) {
  if (w < 40) w= 40;
  return ((100 - w) * 3) + 312;
}

void AfficheTemps(float T) {
  T = T / 1000;
  x = 728;
  fill(0);
  rect(x - 3, 587, 100, 15);
  fill(255);
  text(T + " sec", x, 590);
}

void EffaceEcran() {
  background(255); // Fond blanc
  fill(0, 0, 0); // Texte noir

  // textFont(maFonte, 16);
  //text("Fichier: " + NomFichierPitch + "     ("+ LignesPitch.length + " LignesPitch)", 5, 10);

  textFont(maFonte, 12);
  stroke(0, 0, 0); // Ligne noire

  line(0, YPitch(75), width, YPitch(75));
  text("75Hz", width - 40, YPitch(75) - 10);
  line(0, YPitch(500), width, YPitch(500));
  text("500Hz", width - 40, YPitch(500) + 2);

  text("Pause : Espace", width - 85, 575);

  fill(255, 0, 0); // Texte rouge
  stroke(255, 0, 0); // Ligne rouge
  text("100dB", width - 40, YPitch(75) + 2);
  text("40dB", width - 40, YIntensity(40) - 10);
  line(0, YIntensity(40), width, YIntensity(40));

  // line(0, YIntensity(40), width, YIntensity(100));

  xAvantPitch = 0;
  yAvantPitch = YPitch(75) ;
  xAvantIntensity = 0;
  yAvantIntensity = YIntensity(40) ;
}

void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 2048);
  player.play();
}



void keyPressed() {
  if (key == ' ') {         // barre d'espace
    ToucheEspace = ! ToucheEspace;
    Pause = ToucheEspace;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else   if (keyPressed && (key == CODED)) { // If it's a coded key
    if (keyCode == LEFT) {            // If it's the left arrow
      FacteurX = FacteurX / 2;
      TempsPause = millis();
      IndexPitch = 0;
      IndexIntensity = 0;
      EffaceEcran();
      PlayerAudioDebut();
    } 
    else if (keyCode == RIGHT) {      // If it's the right arrow
      FacteurX = FacteurX * 2;
      TempsPause = millis();
      IndexPitch = 0;
      IndexIntensity = 0;
      EffaceEcran();
      PlayerAudioDebut();
    }
  }

  {
    // println("key = " + key  + "  Erreur taper Espace");
  }
}

void mousePressed() {
  ;
}


void keyReleased() {
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
}  

// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  println("Frame saved");
  //  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}


void stop() {
  // always close Minim audio classes when you are done with them
  player.close();
  minim.stop();
  super.stop();
}

